> For the complete documentation index, see [llms.txt](https://docs.exoclick.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.exoclick.com/rtb/publishers/exoclick-rtb/bid-request.md).

# ExoClick RTB Bid Request

The ExoClick RTB Bid Request is done using JSON for POST and a URL for GET. XML requests are not allowed for POST.

## Bid Request Headers

* **ExoClick RTB Version HTTP Header**: `x-exadsrtb-version: 1.0`
* **Keep-Alive HTTP Header**: `Connection: Keep-Alive`
* **Content JSON**: `Content-Type: application/json`
* **Data Encoding Header**: `Accept-Encoding`

### Bid Request Object

| Attribute         | Required?               | Description                                                                                                                                  |
| ----------------- | ----------------------- | -------------------------------------------------------------------------------------------------------------------------------------------- |
| `id`              | Yes                     | Unique bid request ID (string)                                                                                                               |
| `ip`              | Yes                     | IP address of the user (string)                                                                                                              |
| `language`        | Yes                     | Browser language using ISO-639-1-alpha-2 (string)                                                                                            |
| `remove_addr`     | No                      | Main IP address of the user (string)                                                                                                         |
| `x_forwarded_for` | No                      | X-FORWARDED-FOR IP address of the user or empty if not set (string)                                                                          |
| `type`            | Yes                     | Request type. Can be “banner”, “popunder”, "direct\_link", "email\_click"\*, “push\_notification” or "in\_page\_push\_notification" (string) |
| `ua`              | Yes                     | Browser user agent (string)                                                                                                                  |
| `url`             | Yes                     | Full URL of the page where the ad will be shown (string)                                                                                     |
| `user_id`         | Yes                     | Unique user ID (string)                                                                                                                      |
| `sub`             | No                      | This should be a number between six and ten digits: Do not use zeroes at the beginning of Sub IDs.                                           |
| `export`          | Yes                     | Response type. Can be "json" or "xml" (string)                                                                                               |
| `keyword`         | No                      | Keywords can be used to ensure ad zones get the right type of advertising. Keywords should be a string of comma-separated words.             |
| `size`            | Required for banner\*\* | Publisher ad type size (string)                                                                                                              |
| `el`              | No                      | Base64 Encoded Email. Available only for Email Clicks and Direct Link (string)                                                               |

***

**Notes:**

* `"email_click"` as a type needs to be specified only in GET requests.
* In Push requests, if size is omitted, the default value will be `192x192` for backwards compatibility.
* Sub IDs should be a number between 1 and [Int32](https://docs.microsoft.com/en-us/dotnet/api/system.int32.maxvalue?view=net-5.0): Do not use zeroes at the beginning of Sub IDs.


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.exoclick.com/rtb/publishers/exoclick-rtb/bid-request.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
